/**JScript source code 4 TXT_bravo2.js
*@author Sandy
*/
/**TF_GetExtention() не вызывается. Но если она есть и вызвана, то вернёт 
* маску экспорта. 
*/
function TF_GetExtention(){
	return "*.vvv";
}
/**ReadImpFile вызывается из DpCLB.js и создаёт документы типа DpDoc.
При отсутствии ошибок возвращает true.
@param sFilePath - полный путь к файлу с платёжками.
@param Noper - номер операции для папки, в которой стоим.
@param cimportpppv - отдельно или вместе закачивать документы типов PP PV.
@param cduplic - сообщать или нет о дублирующих документах. 
*/
function ReadImpFile(sFilePath, Noper, cimportpppv, cduplic)
{
	var sFile	= String(ReadTxtFile(sFilePath,"cp1251"));
		nNewLine	= 0,
		nBlank		= 0,
		sLine		= "";

	//переменные для разбора файла
	//префиксы
	//s - sender
	//r - receiver
	var	sDocType,DOC_DAT,DOC_NUM,
	sNAME, sOKPO, sMFO, sACCOUNT,
    rNAME, rOKPO, rMFO, rACCOUNT,
    TOVAR, SUM_UAH, SUM_VAL;	
		
	var	nIndex;

	//осталось из имени файла получить дату
	sFilePath.toUpperCase();
	var nBegin	= sFilePath.indexOf("\\V_");
	if(-1 == nBegin)
		return false;
	nBegin	+= 3;
	year =   2000 + Number(sFilePath.substr(nBegin, 2));
	month=   Number(sFilePath.substr(nBegin+2, 2))-1;
	day  =   Number(sFilePath.substr(nBegin+4, 2));
			
	DOC_DAT = day+"/"+month+"/"+year;
	DOC_DATOBJ = Dp_DATEfromDMY(DOC_DAT)		
	///////////////
	
	while(sFile.length>0)
	{
		nNewLine	= sFile.indexOf('\n');
		if(-1 == nNewLine)
		{
			sLine	= sFile;
			sFile	= "";
		}
		else
		{
			sLine	= sFile.substr(0, nNewLine);
			sFile	= sFile.substr(nNewLine+1);
		}

		//пропускаем пустые строки и обор.сальдовые
		if(sLine.length == 0 || sLine.charAt(0)!='1')
			continue;
		nIndex	= 1;
		//здесь разбираем строку		
		sDocType= sLine.charAt(nIndex++)=='-' ? "PP" : "PV";
		sMFO	= allt(sLine.substr(nIndex, 9));
		nIndex	+= 9;
		sACCOUNT= allt(sLine.substr(nIndex, 14));
		nIndex	+= 14;
		sOKPO	= "";
		sOKPO	= allt(sLine.substr(nIndex, 14));
		nIndex	+= 14;
		sNAME	= allt(sLine.substr(nIndex, 40));
		nIndex	+= 40;

		rMFO	= allt(sLine.substr(nIndex, 9));
		nIndex	+= 9;
		rACCOUNT= allt(sLine.substr(nIndex, 14));
		nIndex	+= 14;
		rOKPO	= "";
		rOKPO	= allt(sLine.substr(nIndex, 14));
		nIndex	+= 14;
		rNAME	= allt(sLine.substr(nIndex, 40));
		nIndex	+= 40;
		//пропустить
		nIndex	+= 2;
		DOC_NUM	= allt(sLine.substr(nIndex, 10));
		nIndex	+= 10;

		SUM_UAH	= allt(sLine.substr(nIndex, 19));
		if(SUM_UAH == "")
			SUM_UAH	= 0;
		else
			SUM_UAH	= Number(SUM_UAH);
		nIndex	+= 19;

		SUM_VAL	= allt(sLine.substr(nIndex, 19));
		if(SUM_VAL == "")
			SUM_VAL	= 0;
		else
			SUM_VAL	= Number(SUM_UAH);
		nIndex	+= 19;
		nIndex	+= 8;
		nIndex	+= 4;
		nIndex	+= 8;
		nIndex	+= 4;

		TOVAR	= allt(sLine.substr(nIndex));
		//здесь из переменных переносим все в запись
		if (!cimportpppv || (cimportpppv == true && DocType == sDocType))	
		{			
			var platDoc = new DpDoc(sDocType, Noper);						
			platDoc.setVar("HNOM", DOC_NUM);
			platDoc.setVar("HTOT", sNAME);
			platDoc.setVar("HCOT", sOKPO);
			platDoc.setVar("HMFOOT", sMFO);				
			platDoc.setVar("HDBSC", sACCOUNT);					
			platDoc.setVar("HTTO", rNAME);			
			platDoc.setVar("HCTO", rOKPO);
			platDoc.setVar("HMFOTO", rMFO);			
			platDoc.setVar("HCRSC", rACCOUNT);
			platDoc.setVar("HVAL", DpValuta(0));
			platDoc.setVar("HTOVAR", TOVAR);
			platDoc.setVar("HSUM", SUM_UAH);
			platDoc.setVar("HNDS", round((SUM_UAH/6),2));   			
			platDoc.setVar("HDAT", DOC_DATOBJ);	
			
			if (cduplic)//proverka dyblei
			{
				if(platDoc.getVar("HDAT")!=null && platDoc.getVar("HNOM")!=null && platDoc.getVar("HSUM")!=null)
				{
					var sqlStr = "SELECT * from ^RAS_SCH WHERE FDOC_NUM = "
						+sqlTo(platDoc.getVar("HNOM"))+" AND FDOC_DAT = "+sqlTo(platDoc.getVar("HDAT"))
						+" AND FDOC = " + sqlTo(sDocType)
						+" AND FFCR_SC = "+sqlTo(platDoc.getVar("HCRSC"))+" AND FFDB_SC = "+sqlTo(platDoc.getVar("HDBSC"))
						+" AND FSUM = "+sqlTo(platDoc.getVar("HSUM"))+" AND FTOVAR = "+sqlTo(platDoc.getVar("HTOVAR"));
					var tdup = OpenTable("s",sqlStr);								
					if (tdup.recordCount > 0)
					{										
						alertStr1 = UR("ОБНАРУЖЕНО "+tdup.recordCount+" ДОКУМЕНТОВ С ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
						+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
						+"\nСУММA "+platDoc.getVar("HSUM")+", ТИП ДОКУМЕНТА "+sDocType
						+"\nИ НАЗНАЧЕНИЕ ПЛАТЕЖА-"+platDoc.getVar("HTOVAR") 
						+"|ЗНАЙДЕНО "+tdup.recordCount+" ДОКУМЕНТІВ З ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
						+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
						+"\nСУМA "+platDoc.getVar("HSUM")+", ВИД ДОКУМЕНТУ "+sDocType
						+"\nТА ПРИЗНАЧЕННЯМ ПЛАТІЖНОГО ДОКУМЕНТУ-"+allt(platDoc.getVar("HTOVAR")));
						alertStr2 = UR("ДОКУМЕНТ С ТАКИМИ САМЫМИ ПАРАМЕТРАМИ ВЫ ИМПОРТИРУЕТЕ.|ДОКУМЕНТ З ТАКИМИ САМИМИ ПАРАМЕТРАМИ ВИ ІМПОРТУЄТЕ.");
						alertStr3 = "\n\n"+UR("ИМПОРТИРОВАТЬ ДОКУМЕНТ?|ІМПОРТУВАТИ ДОКУМЕНТ?");
						alertStr = alertStr1+"\n"+alertStr2+alertStr3+tdup.getValue("FDOC_DAT");
						var bAnswer = confirm(alertStr)
						if (!bAnswer)//importirovat6
						{
							continue;
						}
					}
				}
			}											
			var HORG = 0;
			if (sDocType == "PP")
			{
				HORG = getOrgNum(platDoc.getVar("HCTO"),platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"));//(OKPO,MFO,RSCH)
			}
			else
			{
				HORG = getOrgNum(platDoc.getVar("HCOT"),platDoc.getVar("HMFOOT"),platDoc.getVar("HDBSC"));
			}
			if (HORG == null)
				HORG = 0;					
			platDoc.setVar("HORG", HORG);
			platDoc.save();	
		}	
	}
	return true;
}